Summary:        HAProxy reverse proxy for high availability environments
Name:           haproxy 
Version:        3.1.6 
Release:        1 
License:        GPL-2.0-or-later 
URL:            https://www.haproxy.org/ 
Source0:        %{url}/download/3.1/src/haproxy-%{version}.tar.gz
Source1:        %{name}.logrotate
Source2:        halog.1
Patch1:         haproxy-3.1.6-change.patch
Prefix:         %{_prefix}
	
BuildRequires:  gcc
BuildRequires:  zlib-devel >= 1.2.13 

Requires:       lua >= 5.4.6
Requires:       pcre2 >= 10.40
Requires:       zlib >= 1.2.13

%description
HAProxy is a TCP/HTTP reverse proxy which is particularly suited for high
availability environments. Indeed, it can:
 - route HTTP requests depending on statically assigned cookies
 - spread load among several servers while assuring server persistence
   through the use of HTTP cookies
 - switch to backup servers in the event a main one fails
 - accept connections to special ports dedicated to service monitoring
 - stop accepting connections without breaking existing ones
 - add, modify, and delete HTTP headers in both directions
 - block requests matching particular patterns
 - report detailed status to authenticated users from a URI
   intercepted from the application

%prep
%setup -q
%patch1 -p0

cp %{SOURCE1} .
cp %{SOURCE2} .

%build
export CC="%{__cc__} -O2 -maix64"
export OBJECT_MODE=64
gmake TARGET=aix72-gcc USE_MATH=1 USE_PCRE2=1 USE_LUA=1 LUA_LIB_NAME=lua USE_ZLIB=1 USE_OPENSSL=1
gmake admin/halog/halog
cd admin/iprange/
gmake
cd -

%install
rm -rf ${RPM_BUILD_ROOT}
export OBJECT_MODE=64
make install  DESTDIR=${RPM_BUILD_ROOT} PREFIX=%{prefix}
/opt/freeware/bin/install -D -m 0644 %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
/opt/freeware/bin/install -D -m 0644 %{SOURCE2} ${RPM_BUILD_ROOT}%{_mandir}/man1/halog.1
/opt/freeware/bin/install -D -m 0755 admin/halog/halog  ${RPM_BUILD_ROOT}%{prefix}/bin/halog
/opt/freeware/bin/install -D -m 0755 admin/iprange/iprange  ${RPM_BUILD_ROOT}%{prefix}/bin/iprange
/opt/freeware/bin/install -D -m 0755 admin/iprange/ip6range  ${RPM_BUILD_ROOT}%{prefix}/bin/ip6range

%files
%doc doc/* examples/*
%doc CHANGELOG README VERSION
%license LICENSE
%{_sysconfdir}/logrotate.d/%{name}
%{_sbindir}/%{name}
%{_bindir}/halog
%{_bindir}/iprange
%{_bindir}/ip6range
%{_mandir}/man1/*

%changelog
* Fri Mar 28 2025 Parth Patel <parth.patel7@ibm.com> - 3.1.6-1
- Updated to version 3.1.6
- Built HAProxy-3.1.6 with OPENSSL3

* Thu May 16 2024 Parth Patel <parth.patel7@ibm.com> - 2.9.7-1
- Update to 2.9.7 (#Port to AIX)
